import java.awt.*;
import java.applet.*;
import java.util.*;
import java.net.*;

public class reactionTime extends java.applet.Applet{
	String rts,STR[]={"Reset","Brake","Time","V","unit","Friction","DelayTime","MouseXV","Start","europeqn","feet"};
	Animation anim;
	Dimension area;
        public double lcst=1.;
	public String lunit="m";
	public void init() {
		setBackground(new Color(0xC8,0xDF,0xD0));
		for(int i=0;i<STR.length;i++){
			if((rts=getParameter(STR[i]))!=null)
				STR[i]=new String(rts);
		}
		if(STR[9].compareTo("yes")==0)Animation.european=true;
		else Animation.european =false;
		if(STR[10].compareTo("yes")==0){
			lunit="f";lcst=12.*2.54/100.;
		}else{
			lunit="m";lcst=1.;
		}
		area=size();
                area.setSize(550,400);
		area.height-=80;
		anim=new Animation(this,STR);
		anim.resize(area);
		add("Center",anim);
		anim.p=new control(anim,STR);
		add("South",anim.p);
		anim.reset(true);
		show();
		anim.start();
	}
}

class control extends Panel {
	TextField mouseP,TextV,TextF,TextT;
	Label valueM,mouseLab;
	Choice unit;
	Animation anim;
	Button cg;
	double cst,vini=20;
	String STR[];
	reactionTime ap;
	control(Animation an,String[] s){
		ap=an.ap;
		scale[0]=scale[0]*ap.lcst;
		scale[1]=scale[1]*ap.lcst;
		vini=vini/ap.lcst;
		setBackground(new Color(0xC8,0xDF,0xD0));
		anim=an;
		STR=s;
		setLayout(new GridLayout(2,6));
		Panel p;
		// IST
		p=new Panel();
		p.add(new Label(STR[3]));
		p.add(valueM=new Label(d2String(vini)+ap.lunit+"/s"));
		add(p);
		anim.v=20.0/ap.lcst;
		add(new Label(STR[4]));
		add(new Label(STR[5]));
		add(new Label(STR[6]));
		add(mouseLab=new Label(STR[7]));
		add(new Button(STR[1]));
		// second level
		p=new Panel();
		//if(Animation.european)add(TextV=new TextField(d2String(vini/ap.lcst),3));
		//else
		cst=scale[0];
		add(TextV=new TextField(d2String(vini*cst),3));
		add(unit=new Choice());
		unit.addItem("km/h");
		unit.addItem("mile/h");
		unit.addItem(ap.lunit+"/s");
		unit.select(0);
		//add(p);
		if(Animation.european){
			add(TextF=new TextField("0,8",4));
			add(TextT=new TextField("0,0/3,0",4));
		}else{
			add(TextF=new TextField("0.8",4));
			add(TextT=new TextField("0.0/3.0",4));
		}
		add(mouseP=new TextField("0 , 0",4));
		mouseP.setEditable(false);
		p=new Panel();
		p.add(new Button(STR[0]));
		p.add(new Button(STR[8]));
		add(p);
	}
	double scale[]={3.6,3.6/1.609344,1.0};
	String str;
	String d2String(double val){
		str=String.valueOf((int)(100.*val)/100.);
		if(Animation.european)return str.replace('.',',');
		return str;
	}
	public boolean action(Event ev, Object arg) {
		if (ev.target instanceof Button) {
			String label=(String)arg;
			if(label.equals(STR[0])){
				anim.reset(true);
				mouseLab.setText("Author");
				mouseP.setText("Fu-Kwun Hwang");
				anim.showXY=false;
			}else if (label.equals(STR[1])) anim.brake();
			else if (label.equals(STR[8])){
				mouseLab.setText(STR[7]);
				//cst=scale[unit.getSelectedIndex()];
				//anim.v=Double.valueOf(str.trim()).doubleValue()/cst;
				//anim.setV(Double.valueOf(str.trim()).doubleValue()/cst);
				anim.writeText(anim.xs,anim.ys);
				anim.showXY=true;
				anim.running=true;anim.start();
			}
		}else if(ev.target == TextV){
			//if(Animation.european)
			str=TextV.getText().replace(',','.');
			//else str=TextV.getText();
			try{
				cst=scale[unit.getSelectedIndex()];
				//anim.v=Double.valueOf(str.trim()).doubleValue()/cst;
				anim.setV(Double.valueOf(str.trim()).doubleValue()/cst);
				valueM.setText(d2String(anim.v)+" "+ap.lunit+"/s");
			}catch(NumberFormatException e) {
			}
		}else if (ev.target == unit){
			cst=scale[unit.getSelectedIndex()];
			TextV.setText(d2String(anim.v*cst));
		}

		return true;
	}
}

class Animation extends Canvas  implements Runnable {
	control p;
	URL base;
	Image redLight,greenLight,yellowLight,redCar,Light;
	static boolean european=false;
	public reactionTime ap;
	Animation(reactionTime _ap,String[] s){
		ap=_ap;
		setBackground(Color.white);
		if(ap!=null){
			base=ap.getCodeBase();
			greenLight=ap.getImage(base,"greenLight.gif");
			yellowLight=ap.getImage(base,"yellowLight.gif");
			redLight=ap.getImage(base,"redLight.gif");
			redCar=ap.getImage(base,"redCar.gif");
		}else{
			greenLight=getToolkit().getImage("greenLight.gif");
			redLight=getToolkit().getImage("redLight.gif");
			yellowLight=getToolkit().getImage("yellowLight.gif");
			redCar=getToolkit().getImage("redCar.gif");
		}
		//area=size();
		init();
	}

	// application start from here
	int delay;
	movingCar A;
	void init(){
		delay=50; //  millisec
		MediaTracker tracker;
		//In the init() method:
	    tracker = new MediaTracker(this);
		tracker.addImage(greenLight, 0);
		tracker.addImage(yellowLight, 1);
		tracker.addImage(redLight, 2);
		tracker.addImage(redCar, 3);
		try {
			//Start downloading the images. Wait until they're loaded.
			tracker.waitForAll();
	    } catch (InterruptedException e) {}
		A=new movingCar(0,v,redCar,redCar.getWidth(this),redCar.getHeight(this));
	}
	Dimension area;
	double v=0.,a=0.,t=0.;
	boolean deleted=true,erase=false;
	int count,randomCount,x0=80;
	// reset condition,
	public void reset(boolean resetButton){
		area=size();
		Light=greenLight;
		Graphics g=getGraphics();
		clear(g);
		String str;
		if(Animation.european)str=p.TextF.getText().replace(',','.');
		else str=p.TextF.getText();
		a=-9.8*Double.valueOf(str.trim()).doubleValue();
		A.init(area,2,v);
		A.acceleration(0.);
		randomCount=(int)(Math.random()*100+x0+50);
		count=0;
		condition=false;
		Light=greenLight;
		A.drawCar(g,condition);
		drawLight(g,Light=greenLight);
	}
	public void setV(double velocity){
		v=velocity;
		A.velocity(v);
	}
	// draw Light
	void drawLight(Graphics g,Image light){
			if(light!=null)
				g.drawImage(light,area.width-2*light.getWidth(this),
					20,Color.white,this);
	}

	// animation code
	Thread animThread;
	long startTime=0,lastTime;

	//  This starts the threads.
	void start(){
		//running=true;
		//Start animating!
		if (animThread == null) {
			animThread = new Thread(this);
			animThread.start();
			//Remember the starting time. of thread
			startTime = System.currentTimeMillis();
			lastTime=startTime;
		}
   }
	 public void stop() {
		//Stop the animating thread.
		animThread = null;
  }

	long conditionTime,delta;
	boolean condition=true;
	boolean yellowOff=true;
	public void run() {
		//Just to be nice, lower this thread's priority
		Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
		//This is the animation loop.
		Graphics g=getGraphics();
		while (Thread.currentThread() == animThread) {
			//Advance the animation frame.
			startTime += delay;
			delta=System.currentTimeMillis()-lastTime;
			if(running)advanced(delta/1000.);
			lastTime+=delta;
			try {
				animThread.sleep(Math.max(0,startTime-System.currentTimeMillis()));
			} catch (InterruptedException e) {
				break;
			}
		}
	}
	boolean running=false;
	void advanced(double dt){
			if(!condition){
				if(A.x>randomCount){
				condition=true;
				conditionTime = System.currentTimeMillis();
				Light=redLight;
				}else if(yellowOff&&A.x>x0){
					//drawLight(g,Light=yellowLight);
					Light=yellowLight;
					yellowOff=false;
				}
			}
			moved=A.move(dt);

			repaint(); // advanced in repaint()
	}

	int xs=0,ys;
	boolean drag=false;
	public boolean mouseDown(Event e, int x, int y){
		if(!drag){
			xs=x;
			ys=y;
		}
		writeText(x,y);
		return true;
	}

	public boolean mouseDrag(Event e, int x, int y){
		writeText(x-xs,y-ys);
		return true;
	}

	public boolean mouseUp(Event e, int x, int y){
		writeText(x,y);
		drag=false;
		return true;
	}
	String d2String(double d){
		float d2=(float)((int)(100.*d)/100.);
		String str=String.valueOf(d2);
		if(str.indexOf(".")==-1)str+=".0";
		else if(str.length()-str.indexOf(".")==2)str+="0";
		if(Animation.european)return str.replace('.',',');
		return str;
	}
	void writeText(int x,int y){
		p.mouseP.setText("X="+d2String(x/A.scale/ap.lcst)+ap.lunit+",V="+
				d2String((area.height-y)/A.scale/ap.lcst)+ap.lunit+"/s");
	}
	boolean showXY=true;
	public boolean mouseMove(Event e, int x, int y){
		if(showXY)writeText(x,y);
		return true;
	}
	double delayTime;
	public void brake(){
		if(animThread!=null){
			long newT;
			A.acceleration(a);
			if(condition){
				newT=System.currentTimeMillis();
				delayTime=(newT-conditionTime)/1000.;
				p.TextT.setText(d2String(delayTime)+" + "+d2String(((int)(-v*1000./a))/1000.)+" sec");
				A.markV(getGraphics(),area.height,delayTime,ap.lcst,ap.lunit);
			}
		}
	}

	public void paint(Graphics g){
		g.setColor(Color.black);
		g.drawRect(0,0,area.width-1,area.height-1);
		A.drawHistory(g);
		drawLight(g,Light);
		update(g);
	}

	void clear(Graphics g){
		g.setColor(getBackground());
		//Erase the previous image.
		g.fillRect(0, 0, area.width, area.height);
		g.setColor(Color.black);
		g.drawRect(0,0,area.width-1,area.height-1);
		int pp,val=0;
		double dd=5.*A.scale,dd2=dd*2;
		g.setColor(Color.red);
		for (double d=area.height;d>0.;d-=dd2){
			g.drawLine(0,pp=(int)d,10,pp);
			g.drawString(d2String(val),12,pp);
			val+=10;
			for(int j=1;j<10;j++)
				g.drawLine(0,pp=(int)(d-j*A.scale),2,pp);
			g.drawLine(0,pp=(int)(d-dd),5,pp);
		}
		g.drawString("V(m/s)",45,40);
		g.setColor(Color.black);
		val=0;
		for (double d=0.;d<area.width;d+=dd2){
			g.drawLine(pp=(int)d,0,pp,10);
			g.drawString(d2String(val),pp,20);
			val+=10;
			for(int j=1;j<9;j++)
				g.drawLine(pp=(int)(d+j*A.scale),0,pp,2);
			g.drawLine(pp=(int)(d+dd),0,pp,5);
		}

	}

	boolean moved=false;
	public void update(Graphics g){
		g.setColor(getBackground());
		drawLight(g,Light);
		//A.drawCar(g,false);
		if(running && A.resetX(area.width)){
			clear(g);
			drawLight(g,Light);
		}
		if(condition)	g.setColor(Color.red);
			else g.setColor(Color.black);
		A.drawCar(g,true);
		A.drawV(g,area.height);
		if(running && !moved){
			double ddd=v*v/(2.*a);
			g.drawString(d2String(-ddd/ap.lcst)+ap.lunit,
				A.x+10,area.height-40);
			g.drawString("+ "+d2String(v*delayTime/ap.lcst)+ap.lunit+"     =    "+
				d2String((v*delayTime-ddd)/ap.lcst)+ap.lunit,A.x+90,area.height-40);

			running=false;//stop();
		}
	}
}

//class Car extends Component{
class movingCar {
	Dimension area;
	int x,y;
	double xv[],a;
	oneDmotion XV;
	double scale=5.;
	Image carImage;
	int width,height;
	movingCar(int xi,double v,Image img,int w, int h){
		carImage=img;
		width=w;
		height=h;
		XV=new oneDmotion((double)xi,v);
		xv=XV.xv();
	}
	//Graphics g;
	Vector trace= new Vector();
	void init(Dimension s2,int xi,double v){
		x=xi;
		area=s2;
		y=area.height-2;
		xv[0]=xi;
		xv[1]=v;
		if(trace!=null)trace.removeAllElements();
	}
  boolean resetX(int width){
		if(x>width){
			x-=width;
			xv[0]-=width/scale;
			return true;
		}else return false;
	}
	public void acceleration(double ai){
		a=ai;
	}
	public void velocity(double v){
		xv[1]=v;
	}
	String markString;
	int markXY[]=new int[3];
	String d2String(double d){
		float d2=(float)((int)(100.*d)/100.);
		String str=String.valueOf(d2);
		if(str.indexOf(".")==-1)str+=".0";
		else if(str.length()-str.indexOf(".")==2)str+="0";
		if(Animation.european)return str.replace('.',',');
		return str;
	}
	void markV(Graphics g,int height,double dt,double cst,String unit){
		markString=d2String(dt*xv[1]/cst)+unit;
		markXY[0]=x+width;
		markXY[1]=height-(int)(scale*xv[1]);
		markXY[2]=markXY[0]-(int)(dt*xv[1]*scale);
		drawMark(g);
	}
	void drawMark(Graphics g){
		g.setColor(Color.red);
		g.drawLine(markXY[0],markXY[1]-5,markXY[0],markXY[1]+5);
		g.drawLine(markXY[2],markXY[1]-5,markXY[2],markXY[1]+5);
		// draw String shows reaction distance
		g.drawString(markString,markXY[2],markXY[1]-10);
	}
	public void drawHistory(Graphics g){
		int xy[]=new int[2];
		for(Enumeration e=trace.elements();e.hasMoreElements();){
			xy=(int[])e.nextElement();
			g.drawLine(xy[0],xy[1],xy[0],xy[1]);
		}
		if(markString!=null)drawMark(g);
	}
	public boolean move(double dt){
		// erase privious car
		xv=XV.move(dt,a,xv);
		x=(int)(xv[0]*scale);
		if(xv[1]<0)return false;
		else return true;
	}
	void drawV(Graphics g,int height){
		int xy[]=new int[2];
		xy[1]=height-(int)(scale*xv[1]);
		xy[0]=x+width;
		g.drawLine(xy[0],xy[1],xy[0],xy[1]);
		trace.addElement(xy);
	}
	//int width=16,height=4,tireD=8,tireR=2,tireR2=2*tireR;
	void drawCar(Graphics g,boolean drawit){
		g.drawImage(carImage,x,y-height,null);
	}
}

//*************************************************************/
class oneDmotion extends rk4{
	// calculate one dimension motion which 'a' can change over time
	//rk4:	int n;
	//rk4:	double y[],dydx[],yout[];
	double a=0.,dt=0.;
	oneDmotion(double xi,double vi){
		init(2);
		yout[0]=y[0]=xi;
		yout[1]=y[1]=vi;
	}
	public void derivs (double t,double y[],double dydx[]){
	//* y[0]=x, y[1]=v;
		dydx[0]=y[1];
		dydx[1]=a;
	}
	public double[] move(double dt,double ai,double xv[]){
		a=ai;
		y[0]=xv[0];
		y[1]=xv[1];
		next(dt);
		return yout;
	}
	public double[] xv(){ return yout;}
}

// RK4
abstract class rk4 {
	int n;
	double y[],dydx[],yout[];
	public void init(int dim){
		n=dim;
		y=new double[n];
		dydx=new double[n];
		yout=new double[n];
	}
  public abstract void derivs(double x,double y1[],double dydx[]);

	public void next(double x,double h){ // t & dt
		core(x,h);
	}
	public void next(double h){ // dt
		core(0.,h);
	}
	private void core(double x, double h){
	/* Runge-Kutta forth-order method */
		int i;
		double xh,hh,h6;
		double dym[]=new double[n];
		double dyt[]=new double[n];
		double yt[]=new double[n];
		hh=h*0.5;
		h6=h/6.0;
		xh=x+hh;
		derivs(xh,y,dydx);
		for (i=0;i<n;i++) yt[i]=y[i]+hh*dydx[i];
		derivs(xh,yt,dyt);
		for (i=0;i<n;i++) yt[i]=y[i]+hh*dyt[i];
		derivs(xh,yt,dym);
		for (i=0;i<n;i++) {
			yt[i]=y[i]+h*dym[i];
			dym[i] += dyt[i];
		}
		derivs(x+h,yt,dyt);
		for (i=0;i<n;i++)
			yout[i]=y[i]+h6*(dydx[i]+dyt[i]+2.0*dym[i]);
	}
}


